#include "prolog.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "errors.h"
#include "rpctypes.h"
#include "servdef.h"
#include "toolkit.h"

float tfval[100];

void tmonitorCallback(int id,int cc)
{
  
  if (cc) printf("ATTACH %s %s %s %s: %s\n>", connTable[id]->context,connTable[id]->name,connTable[id]->deviceName,connTable[id]->prop, RPCLastErrorString);
  else printf("%f\n",tfval[id]);
}

int tcloselink(int id)
{
  CloseLink(id);
  return 0;
}

int tmonitor(void *buf,char *dev,char *prp,char *fmt,int len,int tmr,int id)
{
  int i;
  DTYPE dout;

  dout.dFormat = getFormatType(fmt);
  dout.dArrayLength = len;
  dout.data.vptr = buf;
   
  dout.dTag[0] = 0;
  i = AttachLinkEx(dev,prp,&dout,NULL,CA_READ,tmr,tmonitorCallback,CM_REFRESH,id);

  return i < 0 ? -i : 0;
}
int tget(void *buf,char *dev,char *prp,char *fmt,int len,int tmr)
{
DTYPE dout;

  dout.dFormat = getFormatType(fmt);
  dout.dArrayLength = len;
  dout.data.vptr = buf;
  dout.dTag[0] = 0;
  return ExecLinkEx(dev,prp,&dout,NULL,CA_READ,tmr);
}

int tmonitorfloat(char *dev,char *prp,int tmr)
{
int cc;
static id = 1;

  cc = tmonitor(&tfval[id],dev,prp,"FLOAT",1,tmr,id);
  id++;
  return cc;
}

float tgetfloat(char *dev,char *prp,int tmr)
{
float f;
int cc;

  cc = tget(&f,dev,prp,"FLOAT",1,tmr);
  if (cc) f = -1;
  printf("value from tgetfloat == %f\n",f);
  return f; 
}
